
function remove_appends()
 for instrument_index in ipairs(renoise.song().instruments) do
  renoise.song():instrument(instrument_index).name = string.gsub(string.gsub(renoise.song():instrument(instrument_index).name, "%(.*%) ", ""), "%(%) ", "")
 end
end

function append_count()
 renoise.app():show_status("Counting instrument occurances...")
 remove_appends()

 local instruments = { }
 for instrument in ipairs(renoise.song().instruments) do
  instruments[instrument] = 0
 end
 instruments[256] = 0

 for pattern_index in ipairs(renoise.song().patterns) do
  for track_index in ipairs(renoise.song().patterns[pattern_index].tracks) do
   if not renoise.song().patterns[pattern_index].tracks[track_index].is_empty then
    local pattern_iterator = renoise.song().pattern_iterator:note_columns_in_pattern_track(pattern_index, track_index, true)
    for pos, val in pattern_iterator do
     if (not val.is_empty) and instruments[val.instrument_value+1] then
      instruments[val.instrument_value+1] = 1 + instruments[val.instrument_value+1]
     end
    end
   end
  end
 end
 for instrument_index, inst in ipairs(renoise.song().instruments) do
  inst.name = "(" .. instruments[instrument_index] .. ")" .. " " .. inst.name
 end
end


--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------

renoise.tool():add_menu_entry {
  name = "Instrument Box:Count occurances",
  invoke = function() append_count() end
}

renoise.tool():add_menu_entry {
  name = "Instrument Box:Remove count",
  invoke = function() remove_appends()
  renoise.app():show_status("Removed instrument occurances...")  
  end
}
